<%@ Page Language="C#" %>
<%@ Reference Page="sample01a.aspx" %>
<%@ Import Namespace="System.IO" %>
<%@ Import Namespace="System.Data" %>
<html>
<head>
<script runat="server">
SourcePage sp;

void Page_Load(object sender, EventArgs e) {
	if (!IsPostBack) {
		if (Context.Handler is SourcePage) {
			sp = (SourcePage) Context.Handler;
			datagrid.DataSource = CreateDataSource(sp.arg);
			datagrid.DataBind();
		} else {
			datagrid.DataSource = CreateDataSource("");
			datagrid.DataBind();
		}
	}
}

ICollection CreateDataSource(string s) {
	DirectoryInfo di = new DirectoryInfo(Server.MapPath("."));
	FileInfo[] fi = di.GetFiles();

	DataTable dt = new DataTable();
	DataRow dr;

	dt.Columns.Add(new DataColumn("fileid", typeof(int)));
	dt.Columns.Add(new DataColumn("filename", typeof(String)));
	dt.Columns.Add(new DataColumn("filesize", typeof(long)));
	dt.Columns.Add(new DataColumn("date", typeof(DateTime)));

	for (int i = 0; i < fi.Length; i++) {
		dr = dt.NewRow();
		dr[0] = i;
		dr[1] = fi[i].Name;
		dr[2] = fi[i].Length;
		dr[3] = fi[i].LastWriteTime;
		dt.Rows.Add(dr);
	}

	DataView dv = new DataView(dt);
	dv.RowFilter = "filename LIKE '*" + s + "*'";

	return dv;
}

</script>
</head>
<body>
	<asp:DataGrid id="datagrid" Width="90%" runat="server" />
</body>
</html>
